JUCE

- Main Page
- Related Pages
- Topics
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

Loading...
Searching...
No Matches
Public Member Functions | List of all members
FileInputStream Class Reference
juce_core » files

An input stream that reads from a local file. More...

`#include <juce_FileInputStream.h>`

Inheritance diagram for FileInputStream:

## Public Member Functions
| FileInputStream (const File &fileToRead)
| Creates a FileInputStream to read from the given file.
| ~FileInputStream () override
| Destructor.
const File & | getFile () const noexcept
| Returns the file that this stream is reading from.
const Result & | getStatus () const noexcept
| Returns the status of the file stream.
bool | failedToOpen () const noexcept
| Returns true if the stream couldn't be opened for some reason.
bool | openedOk () const noexcept
| Returns true if the stream opened without problems.
int64 | getTotalLength () override
| Returns the total number of bytes available for reading in this stream.
int | read (void *, int) override
| Reads some data from the stream into a memory buffer.
bool | isExhausted () override
| Returns true if the stream has no more data to read.
int64 | getPosition () override
| Returns the offset of the next byte that will be read from the stream.
bool | setPosition (int64) override
| Tries to move the current read position of the stream.
Public Member Functions inherited from InputStream
virtual | ~InputStream ()=default
| Destructor.
int64 | getNumBytesRemaining ()
| Returns the number of bytes available for reading, or a negative value if the remaining length is not known.
ssize_t | read (void *destBuffer, size_t maxBytesToRead)
virtual char | readByte ()
| Reads a byte from the stream.
virtual bool | readBool ()
| Reads a boolean from the stream.
virtual short | readShort ()
| Reads two bytes from the stream as a little-endian 16-bit value.
virtual short | readShortBigEndian ()
| Reads two bytes from the stream as a little-endian 16-bit value.
virtual int | readInt ()
| Reads four bytes from the stream as a little-endian 32-bit value.
virtual int | readIntBigEndian ()
| Reads four bytes from the stream as a big-endian 32-bit value.
virtual int64 | readInt64 ()
| Reads eight bytes from the stream as a little-endian 64-bit value.
virtual int64 | readInt64BigEndian ()
| Reads eight bytes from the stream as a big-endian 64-bit value.
virtual float | readFloat ()
| Reads four bytes as a 32-bit floating point value.
virtual float | readFloatBigEndian ()
| Reads four bytes as a 32-bit floating point value.
virtual double | readDouble ()
| Reads eight bytes as a 64-bit floating point value.
virtual double | readDoubleBigEndian ()
| Reads eight bytes as a 64-bit floating point value.
virtual int | readCompressedInt ()
| Reads an encoded 32-bit number from the stream using a space-saving compressed format.
virtual String | readNextLine ()
| Reads a UTF-8 string from the stream, up to the next linefeed or carriage return.
virtual String | readString ()
| Reads a zero-terminated UTF-8 string from the stream.
virtual String | readEntireStreamAsString ()
| Tries to read the whole stream and turn it into a string.
virtual size_t | readIntoMemoryBlock (MemoryBlock &destBlock, ssize_t maxNumBytesToRead=-1)
| Reads from the stream and appends the data to a MemoryBlock.
virtual void | skipNextBytes (int64 numBytesToSkip)
| Reads and discards a number of bytes from the stream.

## Additional Inherited Members
Protected Member Functions inherited from InputStream
| InputStream ()=default

## Detailed Description

An input stream that reads from a local file.

See also
  InputStream, FileOutputStream, File::createInputStream

## Constructor & Destructor Documentation

## ◆ FileInputStream()

FileInputStream::FileInputStream | ( | const File & | fileToRead | ) |
| explicit

Creates a FileInputStream to read from the given file.

After creating a FileInputStream, you should use openedOk() or failedToOpen() to make sure that it's OK before trying to read from it! If it failed, you can call getStatus() to get more error information.

## ◆ ~FileInputStream()

FileInputStream::~FileInputStream | ( |  | ) |
| override

Destructor.

## Member Function Documentation

## ◆ getFile()

const File & FileInputStream::getFile | ( |  | ) | const
| noexcept

Returns the file that this stream is reading from.

## ◆ getStatus()

const Result & FileInputStream::getStatus | ( |  | ) | const
| noexcept

Returns the status of the file stream.

The result will be ok if the file opened successfully. If an error occurs while opening or reading from the file, this will contain an error message.

## ◆ failedToOpen()

bool FileInputStream::failedToOpen | ( |  | ) | const
| noexcept

Returns true if the stream couldn't be opened for some reason.

See also
  getResult()

## ◆ openedOk()

bool FileInputStream::openedOk | ( |  | ) | const
| noexcept

Returns true if the stream opened without problems.

See also
  getResult()

## ◆ getTotalLength()

int64 FileInputStream::getTotalLength | ( |  | ) |
| override virtual

Returns the total number of bytes available for reading in this stream.

Note that this is the number of bytes available from the start of the stream, not from the current position.

If the size of the stream isn't actually known, this will return -1.

See also
  getNumBytesRemaining

Implements InputStream.

## ◆ read()

int FileInputStream::read | ( | void * | destBuffer,
|  | int | maxBytesToRead )
| override virtual

Reads some data from the stream into a memory buffer.

This is the only read method that subclasses actually need to implement, as the InputStream base class implements the other read methods in terms of this one (although it's often more efficient for subclasses to implement them directly).

Parameters

  destBuffer | the destination buffer for the data. This must not be null.
  maxBytesToRead | the maximum number of bytes to read - make sure the memory block passed in is big enough to contain this many bytes. This value must not be negative.

Returns
  the actual number of bytes that were read, which may be less than maxBytesToRead if the stream is exhausted before it gets that far

Implements InputStream.

## ◆ isExhausted()

bool FileInputStream::isExhausted | ( |  | ) |
| override virtual

Returns true if the stream has no more data to read.

Implements InputStream.

## ◆ getPosition()

int64 FileInputStream::getPosition | ( |  | ) |
| override virtual

Returns the offset of the next byte that will be read from the stream.

See also
  setPosition

Implements InputStream.

## ◆ setPosition()

bool FileInputStream::setPosition | ( | int64 | newPosition | ) |
| override virtual

Tries to move the current read position of the stream.

The position is an absolute number of bytes from the stream's start.

Some streams might not be able to do this, in which case they should do nothing and return false. Others might be able to manage it by resetting themselves and skipping to the correct position, although this is obviously a bit slow.

Returns
  true if the stream manages to reposition itself correctly

See also
  getPosition

Implements InputStream.

The documentation for this class was generated from the following file:

- juce_FileInputStream.h